#ifndef IPSUBSAMPLE_INC
#define IPSUBSAMPLE_INC

#include "ipCore.h"

namespace Torch {

/** This class is designed to subsample an image

    Warning: ratios #width#/#width_out# and #height#/#height_out# should be integers

    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 2.0
*/
class ipSubsample : public ipCore
{
   	// width of the input image
	int width;

	// height of the input image
	int height;

	// width of the output image
	int width_out;

	// height of the output image
	int height_out;

	// ratios
	real ratio_w, ratio_h;
	
public:
	/** constructor
	
	    @param width_in_ is the #width# of the input image
	    @param height_in_ is the #height# of the input image
	    @param coding_ is the #coding# format of the input image
	    @param width_out_ is the #width# of the output image
	    @param height_out_ is the #height# of the output image
	*/
    	ipSubsample(int width_, int height_, char *coding_, int width_out_, int height_out_);

	///
	virtual ~ipSubsample();

	///
	virtual void process(Sequence *seq_in);

	//-----
	
	///
	virtual int getWidthOut(void);

	///
        virtual int getHeightOut(void);

	///
        virtual void setOutputSize(int width, int height);
};

}

#endif
