#include "ipSum.h"

namespace Torch {

ipSum::ipSum(int width_, int height_, const char *coding_) : ipCore(coding_)
{
	width = width_;
        height = height_;

	seq_out = new(allocator) Sequence(n_planes, 1);
}

void ipSum::process(Sequence *seq_in)
{
	int input_size = width * height;
	
	real sum0;
	real sum1;
	real sum2;

	switch(coding_id)
	{
	case 0:
	   	sum0 = 0.0;
		for(int i = 0 ; i < input_size ; i++) 
			sum0 += seq_in->frames[0][i];
        	seq_out->frames[0][0] = sum0;
	
		break;
	case 1:
	case 2:
	   	sum0 = 0.0;
	   	sum1 = 0.0;
	   	sum2 = 0.0;
		for(int i = 0 ; i < input_size ; i++)
		{
			sum0 += seq_in->frames[0][3*i];
			sum1 += seq_in->frames[0][3*i+1];
			sum2 += seq_in->frames[0][3*i+1];
		}
		
        	seq_out->frames[0][0] = sum0;
        	seq_out->frames[1][0] = sum1;
        	seq_out->frames[2][0] = sum2;
	
		break;
	case 3:
		sum0 = 0.0;
                for(int i = 0 ; i < input_size ; i++)
                        sum0 += seq_in->frames[0][i];
                seq_out->frames[0][0] = sum0;

		break;						
	}
}

ipSum::~ipSum()
{
}

}

