const char *help = "\
progname: gohome.cc\n\
code2html: This program controls a Sony pan/tilt/zoom camera to send it at home position.\n\
version: Torch3 vision2.0, 2003-2005\n\
(c) Sebastien Marcel (marcel@idiap.ch)\n";

#include "SonyEviD31.h"
#include "SonyEviD100P.h"

using namespace Torch;

int main()
{
	SonyEviD100P camera("/dev/ttyS", '1');

	if(camera.connect() == false) return 0;
	      
	int powerStatus;
	
	print("Trying to get the power status of the camera.\n");
	powerStatus = camera.getPowerStatus();

	switch(powerStatus)
	{
	case -1: 
	   	print("Error couldn't get the power status.\n");
		break;
	case 0: 
		print("The camera is OFF.\n");
		break;
	case 1: 
		print("The camera is ON.\n");
		camera.goHome();
		break;
	default: 
		print("Unexpected value.\n");
	}
	
	return 1;
}
