#ifndef MEAN_VAR_UNNORM_INC
#define MEAN_VAR_UNNORM_INC

#include "PreProcessing.h"
#include "DataSet.h"
#include "MeanVarNorm.h"

namespace Torch {

/** This class is designed to perform mean and variance un-normalization

    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 2.0
*/
class MeanVarUnNorm : public PreProcessing
{
private:
    void unnormalizeSequence(Sequence *sequence, real *mean, real *stdv);

public:
    
    /// the normalization used
    MeanVarNorm *norm;
    
    ///
    MeanVarUnNorm(MeanVarNorm *norm_);

    ///
    virtual ~MeanVarUnNorm();

    ///
    virtual void preProcessInputs(Sequence *inputs);

    ///
    virtual void preProcessTargets(Sequence *targets);
};

}

#endif
