#ifndef NORM_MEAN_STDV_LIGHT_IMAGE_PREPROCESS_INC
#define NORM_MEAN_STDV_LIGHT_IMAGE_PREPROCESS_INC

#include "PreProcessing.h"
#include "ipNormMeanStdvLight.h"

namespace Torch {

/** This class is designed to normalize an image using the mean and standard deviation of its pixels
 
    @author Sebastien Marcel (marcel@idiap.ch)
    \Date
    @version 2.0
    @since 2.0
*/
class NormMeanStdvImagePreProcessing : public PreProcessing
{
public:
	/// width of the input image
	int width;
	
	/// height of the input image
	int height;

	/// number of inputs
	int n_inputs;

	// the normalization
	ipNormMeanStdvLight *ip_machine;

	///
	NormMeanStdvImagePreProcessing(int width_, int height_);
	
	/// computes the image normalization of the input image in #inputs_# and stores it in #inputs_#
	virtual void preProcessInputs(Sequence *inputs_);
		
	//
	virtual void preProcessTargets(Sequence *targets_);
	
	//
	virtual ~NormMeanStdvImagePreProcessing();
};

}

#endif
