#ifndef VITC_TIMECODE_INC
#define VITC_TIMECODE_INC

#include "TimeCode.h"

namespace Torch {
   
/** This class is designed to extract a VITC timecode from an image
	
    For more info, read the following \URL[document]{http://www.ebu.ch/CMSimages/en/tec_text_n12-1999_tcm6-4753.pdf}.

    @author Sebastien Marcel (marcel@idiap.ch)
    @author Olivier Masson (masson@idiap.ch)
    @version 2.0
    \Date
    @since 2.0
*/
class vitcTimeCode : public TimeCode
{
   	// size of the image
	unsigned long width;
	unsigned long height;

	// Pix Index Array for TimeCode
	unsigned long VITCTimeCodeMask[90];

	//-----
	
	int IsVITCTimeCode(unsigned char *VITCTimeCode_);
	bool InitVITCTimeCode(unsigned char *pixmap_);
	int ReadTimeCode(unsigned char *pixmap_);

public:
	/// constructor
	vitcTimeCode(int width_, int height_);

	/// destructor
	virtual ~vitcTimeCode();

	//-----
	
	///
	virtual bool reset(unsigned char *pixmap_);
};

}

#endif
